---------------------------------------- 
-- Layout Code ------------------------- 
----------------------------------------  

-- In here, all the window elements get
-- created and positioned. This code is
-- pretty much standalone and should not
-- include any complicated handlers or
-- dependencies. It simply draws a window!

----------------------------------------
----------------------------------------
----------------------------------------

function CreateLayout(sVersion,fOnClose)

	MainForm = Obj.Create("TForm")
	MainForm.Left = 320
	MainForm.Top = 320
	MainForm.Width = 700
	MainForm.Height = 420
	MainForm.Font.Name = "Arial"
	MainForm.Font.Size = 8
	MainForm.OnClose = fOnClose
	MainForm.Caption = sVersion
	MainForm.LoadIcon(LoadData("icons/openeuo.ico"))

	do -- MainForm's children:

		BottomPanel = Obj.Create("TPanel")
		BottomPanel.Height = 16
		BottomPanel.BevelOuter = 0
		BottomPanel.Align = C.alBottom
		BottomPanel.Parent = MainForm

		BottomLabel = Obj.Create("TLabel")
		BottomLabel.Top = 1
		BottomLabel.Left = 4
		BottomLabel.Parent = BottomPanel

		ProjectTabCtrl = Obj.Create("TTabControl")
		ProjectTabCtrl.Align = C.alClient
		ProjectTabCtrl.HotTrack = true
		ProjectTabCtrl.Parent = MainForm

		ThreadTabCtrl = Obj.Create("TTabControl")
		ThreadTabCtrl.Align = C.alClient
		ThreadTabCtrl.HotTrack = true
                ThreadTabCtrl.TabPosition = 1
		ThreadTabCtrl.Parent = ProjectTabCtrl
                ThreadTabCtrl.Tabs.Add('Thread 1')

		do -- ThreadTabControl's children:

			VarPanel = Obj.Create("TPanel")
			VarPanel.Width = 150
			VarPanel.BevelOuter = 0
			VarPanel.BevelInner = 0
			VarPanel.Align = C.alRight
			VarPanel.Parent = ThreadTabCtrl

			VarSplitter = Obj.Create("TSplitter")
			VarSplitter.Align = C.alRight
			VarSplitter.AutoSnap = false
			VarSplitter.Parent = ThreadTabCtrl

			MainPanel = Obj.Create("TPanel")
			MainPanel.BevelOuter = 0
			MainPanel.Align = C.alClient
			MainPanel.Parent = ThreadTabCtrl

			do -- MainPanel's children:

				LowerPanel = Obj.Create("TPanel")
				LowerPanel.Height = 95
				LowerPanel.BevelOuter = 0
				LowerPanel.BevelInner = 0
				LowerPanel.Align = C.alBottom
				LowerPanel.Parent = MainPanel

				do -- LowerPanel's children:

                		        StackTabCtrl = Obj.Create("TTabControl")
	                	        StackTabCtrl.Align = C.alTop
                                        StackTabCtrl.Style = C.tsFlatButtons
                                        StackTabCtrl.Height = 21
	                	        StackTabCtrl.Parent = LowerPanel
                                        StackTabCtrl.TabHeight = 19
                                        StackTabCtrl.Tabs.Add('StackLvl 1')

					OutputPanel = Obj.Create("TPanel")
					OutputPanel.Height = 72
					OutputPanel.BevelOuter = 0
					OutputPanel.BevelInner = 0
					OutputPanel.Align = C.alClient
	                		OutputPanel.Font.Name = "Courier New"
        		        	OutputPanel.Font.Size = 10
					OutputPanel.Parent = LowerPanel
				end

				LowerSplitter = Obj.Create("TSplitter")
				LowerSplitter.Align = C.alBottom
				LowerSplitter.AutoSnap = false
				LowerSplitter.Parent = MainPanel

				ScriptPanel = Obj.Create("TPanel")
				ScriptPanel.BevelOuter = 0
				ScriptPanel.BevelInner = 0
				ScriptPanel.Align = C.alClient
			        ScriptPanel.Font.Name = "Courier New"
			        ScriptPanel.Font.Size = 10
				ScriptPanel.Parent = MainPanel
			end
		end
	end

	local filter  = "Lua Files (*.lua)|*.lua|Text Files (*.txt)|*.txt|All Files (*.*)|*.*"

	OpenDialog = Obj.Create("TOpenDialog")
	OpenDialog.DefaultExt = "lua"
	OpenDialog.Filter = filter
	OpenDialog.InitialDir = getinstalldir()
	OpenDialog.Options = 512 --filemustexist

	SaveDialog = Obj.Create("TSaveDialog")
	SaveDialog.DefaultExt = "lua"
	SaveDialog.Filter = filter
	SaveDialog.InitialDir = getinstalldir()
	SaveDialog.Options = 2+256 --overwriteprompt,pathmustexist

	dofile("wndpos.cfg",false)
end

----------------------------------------

function FreeLayout()
	if MainForm.WindowState<2 then
		SaveData("wndpos.cfg",
			VarToData("MainForm.Left")..
			VarToData("MainForm.Top")..
			VarToData("MainForm.Width")..
			VarToData("MainForm.Height")..
			VarToData("OutputPanel.Height")..
			VarToData("VarPanel.Width"))
	end

	Obj.Free(SaveDialog)
	Obj.Free(OpenDialog)

	Obj.Free(StackTabCtrl)
	Obj.Free(OutputPanel)

	Obj.Free(ScriptPanel)
	Obj.Free(LowerSplitter)
	Obj.Free(LowerPanel)

	Obj.Free(MainPanel)
	Obj.Free(VarSplitter)
	Obj.Free(VarPanel)

        Obj.Free(ThreadTabCtrl)
	Obj.Free(ProjectTabCtrl)
	Obj.Free(BottomLabel)
	Obj.Free(BottomPanel)

	Obj.Free(MainForm)
end
