---------------------------------------- 
-- Menu Code --------------------------- 
----------------------------------------  

-- This is where the main menu is built.
-- You can specify a table with handlers
-- which reacts to click events.

----------------------------------------  
----------------------------------------  
----------------------------------------  

local Main = {
	{"File"      ,0,00},
	{"Edit"      ,0,00},
	{"Control"   ,0,00},
	{"Help"      ,0,00},
}

local File = {
	{"New"       ,0,11,"new.ico"  },
	{"Open..."   ,0,12,"open.ico" },
	{"Save"      ,0,13,"save.ico" },
	{"Save As...",0,14},
	{"-"         ,0,00},
	{"Close"     ,0,15,"close.ico"},	
	{"Close All" ,0,16},	
	{"Exit"      ,0,17},
}

local Edit = {
	{"Cut"       ,C.scCtrl+C.scX,21,"cut.ico"  },
	{"Copy"      ,C.scCtrl+C.scC,22,"copy.ico" },
	{"Paste"     ,C.scCtrl+C.scV,23,"paste.ico"},
	{"Delete"    ,0             ,24},
	{"Select All",C.scCtrl+C.scA,25},
	{"-"         ,0             ,00},
	{"Undo"      ,C.scCtrl+C.scZ,26},
}

local Ctrl = {
	{"Start"     ,C.scF9 ,31,"start.ico"  },
	{"Pause"     ,0      ,32,"pause.ico"  },
	{"Stop"      ,0      ,33,"stop.ico"   },
	{"Stop All"  ,C.scF12,34,"stopall.ico"},
	{"-"         ,0      ,00},
	{"Step Into" ,C.scF7 ,35},
	{"Step Over" ,C.scF8 ,36},
	{"Step Out"  ,0      ,37},
}

local Help = {
	{"About..."  ,0,41,"help.ico"},
}

local Close = {
	{"Close"     ,0,15,"close.ico"},	
}

----------------------------------------

local ImageCnt = 0
local ImageList
local Handler
local function BuildMenu(parent,t)
	for k,v in pairs(t) do
		local m = Obj.Create("TMenuItem")
		m.Caption  = v[1]
		m.ShortCut = v[2]
		m.OnClick  = Handler[v[3]]
		if v[4] then
			local s = LoadData("icons/"..v[4])
			ImageList.InsertIcon(ImageCnt,s)
			m.ImageIndex = ImageCnt
			ImageCnt = ImageList.Count
		end
		parent.Add(m)
	end
end

----------------------------------------

local MenuObj
local MainMenu
function CreateMenu(form,tab,hnd)
	ImageList = Obj.Create("TImageList")
	MenuObj   = Obj.Create("TMainMenu")
	MenuObj.Images = ImageList

	MainMenu  = MenuObj.Items
	Handler   = hnd
	BuildMenu(MainMenu           ,Main)
	BuildMenu(MainMenu.GetItem(0),File)
	BuildMenu(MainMenu.GetItem(1),Edit)
	BuildMenu(MainMenu.GetItem(2),Ctrl)
	BuildMenu(MainMenu.GetItem(3),Help)
	form.Menu = MenuObj

	TabPopup = Obj.Create("TPopupMenu")
	TabPopup.Images = ImageList
	BuildMenu(TabPopup.Items,Close)
	tab.PopupMenu = TabPopup

	EditPopup = Obj.Create("TPopupMenu")
	EditPopup.Images = ImageList
	BuildMenu(EditPopup.Items,Edit)
end

----------------------------------------

function FreeMenu()
	--...
	Obj.Free(EditPopup)
	Obj.Free(TabPopup)
	Obj.Free(ImageList)
	Obj.Free(MenuObj)
end
